<?php
include('sqldb.php');
include('mysql.php');
// Probable variants:
// mssql.php
// postgres.php

ini_set("session.gc_probability", 100);

class SessionHandler
{
        function sess_open($save_path, $session_name)
        {
                global $db;
                if(is_null($db)) $db = new MySQL();
                // Probable variants:
                // = new MSSQL();
                // = new PostgreSQL();
                return true;
        }

        function sess_close()
        {
                // Automatic DB connection closing
                return true;
        }

        function sess_read($id)
        {
                global $db;
                $db->Query("SELECT session_data FROM sessions WHERE session_key = '$id' AND valid = 'yes'");
                return $db->Field();
        }

        function sess_write($id, $sess_data)
        {
                global $db;
                $db->Query("SELECT session_id FROM sessions WHERE session_key = '$id' AND valid = 'yes'");
                if($db->NumRows())
                {
                        $session_id = $db->Field();
                        $sql = "UPDATE sessions SET session_data = '".mysql_real_escape_string($sess_data)."', create_ts = now() WHERE session_id = $session_id";
                }
                else
                {
                        $sql = "INSERT INTO sessions (create_ts, valid, session_key, session_data) VALUES (now(), 'yes', '". mysql_real_escape_string($id) ."', '". mysql_real_escape_string($sess_data) ."')";
                }
                $db->Query($sql);
                return true;
        }

        function sess_destroy($id)
        {
                global $db;
                $db->Query("UPDATE sessions SET valid = 'no' WHERE session_key = '$id'");
                return true;
        }

        function sess_gc($maxlifetime)
        {
                global $db;
                $db->Query("UPDATE sessions SET valid = 'no' WHERE valid = 'yes' AND create_ts < DATE_ADD(now(), INTERVAL -$maxlifetime SECOND)");
                $db->Query("DELETE FROM sessions WHERE valid = 'no'");
                return true;
        }
}

session_set_save_handler(
                         array("SessionHandler", "sess_open"),
                         array("SessionHandler", "sess_close"),
                         array("SessionHandler", "sess_read"),
                         array("SessionHandler", "sess_write"),
                         array("SessionHandler", "sess_destroy"),
                         array("SessionHandler", "sess_gc")
) or die("Failed to register session handler");
?>